/* 
Fertiger Code

Alle Bibliotheken die noch nicht in der Bibliotheken-Verwaltung hinterlegt bzw in der Arduino IDE eingebunden sind, 
müssen vor dem hochladen noch installiert werden. 

Dies ist die Version mit Wlan-Anbindung an einen MQTT Broker.


*/
#include <ESP8266WiFi.h>
#include <PubSubClient.h>
#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>
#include <LiquidCrystal_I2C.h>
#include <NewPing.h>
//Sensor zum Beispiel: HC-SR04 an folgende PINS angeschlossen: 
#define TRIG_PIN D5
#define ECHO_PIN D6
//Max. Entfernung die messbar ist
#define MAX_DIST 400
NewPing sonar(TRIG_PIN, ECHO_PIN, MAX_DIST);
bool schale = false;
LiquidCrystal_I2C lcd(0x27,20,4);
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver(&Wire, 0x40);
//LED FADE
#define UP 0
#define DOWN 1
const int minPWM = 0;
const int maxPWM = 220;
byte fadeDirection = UP;
int fadeValue = 0;
byte fadeIncrement = 20;
unsigned long previousFadeMillis;
int fadeInterval = 100;
// LED FADE
#define SERVOMIN  120 
#define SERVOMAX  600 
int telltime = 0;
long lasttime = millis();
long int behaelter1 = 0;
long int behaelter2 = 0;
long int behaelter3 = 0;
long int behaelter4 = 0;
long int behaelter5 = 0;
long int gemischt = 0;
int counter_led = 0;
char tmp[50];
long lastMsg = 0;
char msg[50];
int x = 0;
int raute = 0;

char ssid[] = "FRITZ!Box 7362 SL";  //  your network SSID (name)
char pass[] = "";       // your network password
const char* mqtt_server = "192.168.178.62"; //Broker IP Address
const char* mqttUser = "iobroker";
const char* mqttPassword = "";
WiFiClient espClient; 
PubSubClient client(espClient); 

void connect_to_MQTT() {
 client.setServer(mqtt_server, 1886);//MQTT Server-Details
  client.setCallback(callback);

  if (client.connect("Suessigkeitenautomat" , mqttUser, mqttPassword)) {
    Serial.println("Verbinde zum MQTT Server");
    client.subscribe("status/#");
  } else {
    Serial.println("zu MQTT Server nicht verbunden ");
  }
}

void setup(){
  WiFi.begin(ssid, pass);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");

  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  connect_to_MQTT();
  pinMode(1,OUTPUT);
  pinMode(3,OUTPUT);
  lcd.begin(20,4);
  lcd.init();
  pwm.begin();
  pwm.setPWMFreq(60);
  Serial.begin(9600);
  Serial.print("Starte das Script");
}


  
void loop(){

//Prüfe zuerst ob eine Schale in dem Automaten steht, gibt true oder false zurück
bereit();
if(schale == false) {
  ausgabe();
} else {
  ausgabe();
}
// LED FADE
  if ( (millis() - telltime) > 600000 ) {
    unsigned long currentMillis = millis();
    doTheFade(currentMillis);
    standby();
    //telltime = millis();
  } 
  // LED FADE
  //Wurde neu gestartet? Lass die Lampen 2 mal leuchten. Und setze den Bildschirm für kurze Zeit auf eine Standard Ausgabe:
  if(counter_led == 0) {
    lcd.backlight();
    lcd.setCursor(0,0);
    lcd.print("Suessigkeitenautomat");
    lcd.setCursor(0,1);
    lcd.print("    Version 1.2     ");
    lcd.setCursor(0,2);
    lcd.print("Gestartet: warte auf");
    lcd.setCursor(0,3);
    lcd.print("ersten Tastendruck  ");
    start_funktion();
  }
  if (!client.connected()) {
    Serial.println("Keine Verbindung zum MQTT Server");
    connect_to_MQTT();
  }
  //Serial Nachrichten -> NANO Lesen
  if (Serial.available() > 0) {
  char customKey = Serial.read();
  if(customKey) {
 Serial.print(customKey);
  }
    
 
//Satistik Menü
if (customKey =='*'){
  telltime = millis();
  //Setze LCD AUF 0
  //Clear ist langsamer als die Zeichen mit "leer" zu Überschreiben
 lcd.setCursor(0,0);
 lcd.print("                    ");
 lcd.setCursor(0,1);
 lcd.print("                    ");
 lcd.setCursor(0,2);
 lcd.print("                    ");
 lcd.setCursor(0,3);
 lcd.print("                    ");
    lcd.setCursor(0,0);
    lcd.print("Behaelter 1:");
    lcd.setCursor(0,1);
    lcd.print("Behaelter 2:");
    lcd.setCursor(0,2);
    lcd.print("Behaelter 3:");
    lcd.setCursor(0,3);
    lcd.print("Behaelter 4:");
    lcd.setCursor(14,0);
    lcd.print(behaelter1);
    lcd.setCursor(14,1);
    lcd.print(behaelter2);
    lcd.setCursor(14,2);
    lcd.print(behaelter3);
    lcd.setCursor(14,3);
    lcd.print(behaelter4);
    delay(5000);
    lcd.setCursor(0,0);
    lcd.print("                    ");
    lcd.setCursor(0,1);
    lcd.print("                    ");
    lcd.setCursor(0,0);
    lcd.print("Behaelter 5:");
    lcd.setCursor(0,1);
    lcd.print("Gemischt:");
    lcd.setCursor(14,0);
    lcd.print(behaelter5);
    lcd.setCursor(14,1);
    lcd.print(gemischt);
    lcd.setCursor(0,2);
    lcd.print("                    ");
    lcd.setCursor(0,3);
    lcd.print("                    ");
    delay(5000);
    ausgabe();
 }
  
//geheimmenü -> Bis jetzt ohne Funktion! 
  if (customKey =='6'){
  x++;
 } 
 if (x == 3) {
  //Wurde nach 666 raute gedrückt?
  if(customKey =='#' && x == 3) {
    telltime = millis();
  lcd.setCursor(0,0);
    lcd.print("Geheimmenü          ");
    lcd.setCursor(0,1);
    lcd.print("wird getestet       ");
    lcd.setCursor(0,2);
    lcd.print("noch ohne Funktion  ");
    lcd.setCursor(0,3);
    lcd.print("Ideen???????        ");
    Serial.print("Bist im Geheim-Menü");
    //counter zurück setzen
    x = 0;
  }
 }
  //Prüfe ob die Schale drin steht! Bei jedem Behälter
  if (customKey =='5' && schale == true){
    //Setze Zeit zurück
    telltime = millis();
    //Setze LED auf 0
    setLed();
    pwm.setPWM(5,0,led(250));
    lcd.setCursor(0,0);
    lcd.print("  Taste 5 gewaehlt  ");
    lcd.setCursor(0,1);
    lcd.print("  Behaehlter  wird  ");
    lcd.setCursor(0,2);
    lcd.print("     geoeffnet     !");
    lcd.setCursor(0,3);
    lcd.print("   Gute Wahl : - )  ");
    pwm.setPWM(0,0,winkel(60));
    delay(1000);
    pwm.setPWM(5,0,led(0));
    pwm.setPWM(0,0,winkel(10));
    behaelter5++;
    ausgabe();
    //Sende an MQTT
    itoa(customKey,tmp,10);
    client.publish("status/zuletzt",tmp);
    Serial.println(tmp);
    x = 0;
    telltime = millis();
  }
  if (customKey =='4' && schale == true){
     //Setze Zeit zurück
    telltime = millis();
    //Setze LED auf 0
    setLed();
    pwm.setPWM(6,0,led(250));
    lcd.setCursor(0,0);
    lcd.print("  Taste 4 gewaehlt  ");
    lcd.setCursor(0,1);
    lcd.print("  Behaehlter  wird  ");
    lcd.setCursor(0,2);
    lcd.print("     geoeffnet     !");
    lcd.setCursor(0,3);
    lcd.print("   Jammi Jammi :-)  ");
    pwm.setPWM(1,0,winkel(65));
    delay(1000);
    pwm.setPWM(1,0,winkel(15));
    pwm.setPWM(6,0,led(0));
    behaelter4++;
    ausgabe();
    //sende an MQTT
    itoa(customKey,tmp,10);
    client.publish("status/zuletzt",tmp);
    Serial.println(tmp);
    x = 0;
    telltime = millis();
  }
  if (customKey =='3' && schale == true){
    //Setze Zeit zurück
    telltime = millis();
    //Setze LED auf 0
    setLed();
    pwm.setPWM(7,0,led(250));
    lcd.setCursor(0,0);
    lcd.print("  Taste 3 gewaehlt  ");
    lcd.setCursor(0,1);
    lcd.print("  Behaehlter  wird  ");
    lcd.setCursor(0,2);
    lcd.print("     geoeffnet     !");
    lcd.setCursor(0,3);
    lcd.print(" Lecker ist das :-) ");
    pwm.setPWM(2,0,winkel(45));
    delay(1000);
    pwm.setPWM(7,0,led(0));
    pwm.setPWM(2,0,winkel(5));
    behaelter3++;
    ausgabe();
    //sende an MQTT
    itoa(customKey,tmp,10);
    client.publish("status/zuletzt",tmp);
    Serial.println(tmp);
    x = 0;
    telltime = millis();
  }
  if (customKey =='2' && schale == true){
    //Setze Zeit zurück
    telltime = millis();
    //Setze LED auf 0
    setLed();
    pwm.setPWM(8,0,led(250));
    lcd.setCursor(0,0);
    lcd.print("  Taste 2 gewaehlt  ");
    lcd.setCursor(0,1);
    lcd.print("  Behaehlter  wird  ");
    lcd.setCursor(0,2);
    lcd.print("     geoeffnet     !");
    lcd.setCursor(0,3);
    lcd.print("   Wohlschmeckend   ");
    pwm.setPWM(3,0,winkel(55));
    delay(1000);
    pwm.setPWM(8,0,led(0));
    pwm.setPWM(3,0,winkel(7));
    behaelter2++;
    ausgabe();
    //sende an MQTT
    itoa(customKey,tmp,10);
    client.publish("status/zuletzt",tmp);
    Serial.println(tmp);
    x = 0;
    telltime = millis();
  }
  if (customKey =='1' && schale == true){
    //Setze Zeit zurück
    telltime = millis();
    //Setze LED auf 0
    setLed();
    pwm.setPWM(9,0,led(250));
    lcd.setCursor(0,0);
    lcd.print("  Taste 1 gewaehlt  ");
    lcd.setCursor(0,1);
    lcd.print("  Behaehlter  wird  ");
    lcd.setCursor(0,2);
    lcd.print("     geoeffnet     !");
    lcd.setCursor(0,3);
    lcd.print("  delikat  delikat  ");
    pwm.setPWM(4,0,winkel(45));
    delay(1000);
    pwm.setPWM(9,0,led(0));
    pwm.setPWM(4,0,winkel(0));
    behaelter1++;
    ausgabe();
    //sende an MQTT
    itoa(customKey,tmp,10);
    client.publish("status/zuletzt",tmp);
    Serial.println(tmp);
    x = 0;
    telltime = millis();
  }
  if (customKey =='A' && schale == true){
    //Setze Zeit zurück
    telltime = millis();
    //Setze LED auf 0
    setLed();
    pwm.setPWM(5,0,led(250));
    pwm.setPWM(6,0,led(250));
    pwm.setPWM(7,0,led(250));
    pwm.setPWM(8,0,led(250));
    pwm.setPWM(9,0,led(250));
    pwm.setPWM(10,0,led(250));
    lcd.setCursor(0,0);
    lcd.print("Gemischt    Gemischt");
    lcd.setCursor(0,1);
    lcd.print("  Dann lass Dir es  ");
    lcd.setCursor(0,2);
    lcd.print("      wirklich      ");
    lcd.setCursor(0,3);
    lcd.print("   gut schmecken!   ");
    pwm.setPWM(0,0,winkel(60));
    delay(100);
    pwm.setPWM(1,0,winkel(65));
    delay(100);
    pwm.setPWM(2,0,winkel(45));
    delay(100);
    pwm.setPWM(3,0,winkel(55));
    delay(100);
    pwm.setPWM(4,0,winkel(45));
    delay(500);
    pwm.setPWM(0,0,winkel(10));
    pwm.setPWM(1,0,winkel(15));
    pwm.setPWM(2,0,winkel(5));
    pwm.setPWM(3,0,winkel(7));
    pwm.setPWM(4,0,winkel(0));
    pwm.setPWM(5,0,led(0));
    pwm.setPWM(6,0,led(0));
    pwm.setPWM(7,0,led(0));
    pwm.setPWM(8,0,led(0));
    pwm.setPWM(9,0,led(0));
    pwm.setPWM(10,0,led(0));
    gemischt++;
    ausgabe();
    //sende an MQTT
    itoa(customKey,tmp,10);
    client.publish("status/zuletzt",tmp);
    Serial.println(tmp);
    x = 0;
    telltime = millis();
  }
}
}
//Servo Winkel anfahren ( Winkel ( wert ) ) 
int winkel(int ang){
   int pulse = map(ang,0, 180, SERVOMIN,SERVOMAX);// map angle of 0 to 180 to Servo min and Servo max 
   Serial.print("Angle: ");Serial.print(ang);
   Serial.print(" pulse: ");Serial.println(pulse);
   return pulse;
}

//LED >FUKTION 
void start_funktion() {
  //LED Blinken lassen und dann stoppen
    pwm.setPWM(5,0,led(250));
    pwm.setPWM(6,0,led(250));
    pwm.setPWM(7,0,led(250));
    pwm.setPWM(8,0,led(250));
    pwm.setPWM(9,0,led(250));
    pwm.setPWM(10,0,led(250));
    delay(500);
    pwm.setPWM(5,0,led(0));
    pwm.setPWM(6,0,led(0));
    pwm.setPWM(7,0,led(0));
    pwm.setPWM(8,0,led(0));
    pwm.setPWM(9,0,led(0));
    pwm.setPWM(10,0,led(0));
    delay(500);
    pwm.setPWM(5,0,led(250));
    pwm.setPWM(6,0,led(250));
    pwm.setPWM(7,0,led(250));
    pwm.setPWM(8,0,led(250));
    pwm.setPWM(9,0,led(250));
    pwm.setPWM(10,0,led(250));
    delay(500);
    pwm.setPWM(5,0,led(0));
    pwm.setPWM(6,0,led(0));
    pwm.setPWM(7,0,led(0));
    pwm.setPWM(8,0,led(0));
    pwm.setPWM(9,0,led(0));
    pwm.setPWM(10,0,led(0));
    counter_led = 1;
}

//LED Schaltung -> Sende Pulse 
int led(int ang2){
   int pulse2 = map(ang2,0, 180, 0,300);
   Serial.print("Angle: ");Serial.print(ang2);
   Serial.print(" pulse: ");Serial.println(pulse2);
   return pulse2;
}

//Standard LCD Ausgabe
//ggf. Anpassen ( 20 Zeichen Max. pro Zeile! )
void ausgabe() {
  if (schale == true) {
  lcd.backlight();
    lcd.setCursor(0,0);
    lcd.print("Suessigkeitenautomat");
    lcd.setCursor(0,1);
    lcd.print("     WirZuhause     ");
    lcd.setCursor(0,2);
    lcd.print("   Betriebsbereit   ");
    lcd.setCursor(0,3);
    lcd.print("  Triff Deine Wahl  ");
  } else {
    standby();
  }
}

// Ausgabe wenn lange nichts passiert ist
void standby() {
  if (schale == false) {
   //Serial.print("Ausgabe LCD Standby");
  lcd.backlight();
    lcd.setCursor(0,0);
    lcd.print("Suessigkeitenautomat");
    lcd.setCursor(0,1);
    lcd.print(" Wartet auf Ausgabe ");
    lcd.setCursor(0,2);
    lcd.print("  Schale oder Dose  ");
    lcd.setCursor(0,3);
    lcd.print("   bereitstellen!   ");
  } else {
    ausgabe();
  }
}

//Zeitspiel = Wenn lange nichts passiert ist, lass die led ein wenig hin und her laufen
void doTheFade(unsigned long thisMillis) {
  // Ist es nun Zeit?
  // Wenn nicht, passiert auch nichts
  if (thisMillis - previousFadeMillis >= fadeInterval) {
    // Jetzt ist es Zeit!
    if (fadeDirection == UP) {
      fadeValue = fadeValue + fadeIncrement;  
      if (fadeValue >= maxPWM) {
        // max und limit
        fadeValue = maxPWM;
        fadeDirection = DOWN;
      }
    } else {
      //if we aren't going up, we're going down
      fadeValue = fadeValue - fadeIncrement;
      if (fadeValue <= minPWM) {
        // At min, limit and change direction
        fadeValue = minPWM;
        fadeDirection = UP;
      }
    }
    //LED die angesteuert werden soll 
    pwm.setPWM(5,0,led(fadeValue + 5));
    pwm.setPWM(6,0,led(fadeValue + 10));
    pwm.setPWM(7,0,led(fadeValue + 15));
    pwm.setPWM(8,0,led(fadeValue + 20));
    pwm.setPWM(9,0,led(fadeValue + 25));
    pwm.setPWM(10,0,led(fadeValue + 30));
    // reset millis for the next iteration (fade timer only)
    previousFadeMillis = thisMillis;
  }
}

void setLed() {
    pwm.setPWM(5,0,led(0));
    pwm.setPWM(6,0,led(0));
    pwm.setPWM(7,0,led(0));
    pwm.setPWM(8,0,led(0));
    pwm.setPWM(9,0,led(0));
    pwm.setPWM(10,0,led(0));
}

void bereit() {
  unsigned int distanceCM = sonar.ping_cm();
  //Diesen Wert ggf anpassen, einmal ausmessen und Werte eintragen, bei mir waren es zwischen 18 und 25
  //Prüfe ob der ein Objekt im Bereich: zwischen 18 und 25 liegt:
if(!distanceCM <= 18 && distanceCM >= 25 ) 
{
  schale = false;
} else {
schale = true;
}
}



void callback(char* topic, byte* payload, unsigned int length) {
// noch ohne funktion
}
